// Half-Edgef[^\̒`
// 2012/4_ł̃bVf[^̃[
// Oppb`lppb`ƂD
// Oppb`Ǝlppb`݂̍͋ȂD

#ifndef _HALF_EDGE_H_
#define _HALF_EDGE_H_

#include "StdAfx.h"
#include "KodListFunc.h"

#define MAXVERTNUMINFACE	4		// 1̃bV_̏(lp`܂)
#define TRIMESHVERTNUM		3		// OpbV̒_
#define QUADMESHVERTNUM		4		// lp`bV̒_

class HEedge;
class HEvert;
class HEface;

// _NX̒`
class HEvert{
public:
	HEvert() {cod=InitCoord(); edge=NULL; index=-1; mom = NULL; qemQ=NULL; NewQEM(); flag = false;}	// RXgN^
	Coord	GetCoord()	{return cod;}			// ̒_̍WlԂ
	HEedge	*GetHE()	{return edge;}			// ̒_Lтn[tGbW1Ԃ
	int		GetIndex()	{return index;}			// ̒_̃CfbNXԂ
	int    GetFlag()	{return flag;}			// tOԂ

	void NewQEM();				// qemQ̃m(4x4)
	void DelQEM();				// qemQ̃
	void InitQEM();				// qemQ̏
	int SetQEM(Matrix);			// qemp[^Zbg
	int AddQEM(Matrix);			// qemp[^
	double **GetQEM();			// qemp[^𓾂

public:
	void SetEdge(HEedge *e)	{edge = e;}			// ̒_Lтn[tGbWZbg
	void SetCod(Coord c)	{cod = c;}			// ̒_̍WlZbg
	void SetIndex(int n)	{index = n;}		// ̒_̃CfbNXZbg
	void SetFlag(int f)		{flag = f;}			// tOZbg


public:
	Coord  cod;		// ̒_̎OW
	HEedge *edge;	// ̒_Lтn[tGbWւ̃|C^(F_LтHE1{Ƃ͌ȂBǂHEƌqĂ邩Ȃ)
	int    index;	// CfbNX
	Data   *mom;	// ẽAhX
	double **qemQ;	// QEM@pWs
	int   flag;		// ėptO
};

// n[tGbWNX̒`
class HEedge{
public:
	HEedge() {vert=NULL; pair=NULL; face=NULL; ne=NULL; index=-1; mom = NULL; InitQEMP(); InitQEMD();}	// RXgN^
	HEvert	*GetStartVert()		{return vert;}			// ̃n[tGbW̎n_Ԃ
	Coord	GetStartVcoord()	{return vert->cod;}		// ̃n[tGbW̎n_WԂ
	HEedge	*GetPairHE()		{return pair;}			// ̃n[tGbW̑΂ƂȂn[tGbWԂ
	HEface	*GetFace()	{return face;}					// ̃n[tGbWʂԂ
	HEedge	*GetNextHE()		{return ne;}			// ̃n[tGbW̎̃n[tGbWԂ
	HEedge  *GetPrevHE();								// ̃n[tGbW(Lʂɂ)1Õn[tGbWԂ
	int		GetIndex()			{return index;}			// ̃n[tGbW̃CfbNXԂ
	int		GetStartVindex()	{return vert->index;}	// ̃n[tGbW̎n_̃CfbNXԂ
	int		GetFlag()			{return flag;}			// tOԂ
	
	void InitQEMP()				{qemP = InitCoord();}	// qemP̏
	void InitQEMD()				{qemD = 0;}				// qemD̏
	void SetQEMP(Coord p)		{qemP = p;}				// qemPZbg
	void SetQEMD(double d)		{qemD = d;}				// qemDZbg
	Coord GetQEMP()				{return qemP;}			// qemPԂ
	double GetQEMD()			{return qemD;}			// qemDԂ

public:
	void SetVert(HEvert *v)		{vert = v;}				// ̃n[tGbW̎n_Zbg
	void SetPair(HEedge *e)		{pair = e;}				// ̃n[tGbW̑΂ƂȂn[tGbWZbg
	void SetFace(HEface *f)		{face = f;}				// ̃n[tGbWʂZbg
	void SetNextHE(HEedge *e)	{ne = e;}				// ̃n[tGbW̎̃n[tGbWZbg
	void SetIndex(int n)		{index = n;}			// ̃n[tGbW̃CfbNXZbg
	void SetFlag(int f)			{flag = f;}				// tOZbg

public:
	HEvert *vert;	// ̃n[tGbW̎n_ւ̃|C^
	HEedge *pair;	// ΂ƂȂtn[tGbWւ̃|C^
	HEface *face;	// ̃n[tGbWɐڂĂʂւ̃|C^
	HEedge *ne;		// ʎ̎̃n[tGbWւ̃|C^
	int    index;	// CfbNX
	Data   *mom;	// ẽAhX

	Coord  qemP;		// QEM@p(Edge CollapseKp̒_ʒu)
	double qemD;		// QEM@p(Edge CollapseKp̃RXg)
	int   flag;			// ėptO
};

// ʃNX̒`
class HEface{
public:
	HEface() {edge=NULL; index=-1; vertnum=0; mom = NULL;}	// RXgN^
	HEedge	*GetStartHE()	{return edge;}		// ̖ʂn[tGbW1Ԃ
	Coord	GetNormVec()	{return norm;}		// ̖ʂ̖@xNgԂ
	double	GetArea()		{return area;}		// ̖ʂ̖ʐςԂ
	int		GetIndex()		{return index;}		// ̖ʂ̃CfbNXԂ
	int		GetVetexNum()	{return vertnum;}	// ̖ʂ̎_Ԃ
	DispStat GetDispStat()	{return Dstat;}		// ̖ʂ̕\Ԃ

public:
	void SetNormVec(Coord n)	{norm = n;}		// ̖ʂ̖@xNgZbg
	void SetFaceArea(double a)	{area = a;}		// ̖ʂ̖ʐςZbg
	void SetEdge(HEedge *e)		{edge = e;}		// ̖ʂn[tGbW1Zbg
	void SetVertNum(int n)		{vertnum = n;}	// ̖ʂ̎_Zbg
	void SetIndex(int n)		{index = n;}	// ̖ʂ̃CfbNXZbg

public:
	HEedge *edge;	// ̖ʂɐڂĂn[tGbW̍ŏ
	Coord  norm;	// @xNg
	double area;	// ʐ
	int    vertnum;	// _
	int    index;	// CfbNX
	DispStat Dstat;	// \iFr,g,bj
	Data   *mom;	// ẽAhX
};

// bVNX̒`
class MESH
{
public:
	MESH();										// RXgN^
	int clear();								// bVS
	void DelVert(HEvert *);						// w肵_
	void DelEdge(HEedge *);						// w肵n[tGbW
	void DelFace(HEface *);						// w肵ʂ
	HEvert *getIndexedVert(int);				// w肵CfbNXƓCfbNX_To
	HEedge *getIndexedEdge(int);				// w肵CfbNXƓCfbNXn[tGbWTo
	HEface *getIndexedFace(int);				// w肵CfbNXƓCfbNXʂTo
	HEedge *setSentinelOnIndexedEdge(int);		// w肵CfbNX̃GbWf[^Ɋ𗧂Ă
	HEedge *getIndexedEdgeFromSentinel(int);	// nԖڌorÕGbWf[^𓾂
	int CalcFaceNorm(HEface *);					// w肵f̖@xNg߁Af->normɃZbg
	int CalcFaceArea(HEface *);					// w肵f̖ʐς߁Af->areaɃZbg
	void EdgeSortbyQEMD();						// EdgeQEMRXg(Edge.qemD)ŏ\[g
	void InsertQEMD(HEedge *);					//	\[gꂽEdgeXgɁAύXꂽQEMRXgHEedge}


private:
	Data *MergeSortForQEMD(Data *);				// EdgeQEMRXg(Edge.qemD)ŏ\[gSub1
	Data *MergeListForQEMD(Data *,Data *);		// EdgeQEMRXg(Edge.qemD)ŏ\[gSub2


public:
	KODlistData Face;		// ʃXg̃[g
	KODlistData Edge;		// n[tGbWXg̃[g
	KODlistData Vert;		// _Xg̃[g
	int VertNum;			// ʂ̑
	int EdgeNum;			// n[tGbW̑
	int FaceNum;			// _̑
};

#endif